/* The copyright in this software is being made available under the BSD
 * License, included below. This software may be subject to other third party
 * and contributor rights, including patent rights, and no such rights are
 * granted under this license.  
 *
 * Copyright (c) 2010-2011, ITU/ISO/IEC
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  * Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
 *    be used to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

/** \file     TComCABACTables.cpp
 *  \brief    static class for CABAC tables
 */

#include "TComCABACTables.h"

#if !MULTI_PAR_CABAC_PROB_UP_DATE || MULT_LESS
#if MULT_LESS
	const UShort TComCABACTables::sm_aucLPSTable[128][32] =
			{
				{      1,      1,      1,      1,      1,      1,      1,      1,      1,      1,      1,      1,      1,      1,      1,      1,      2,      2,      2,      2,      2,      2,      2,      2,      2,      2,      2,      2,      2,      2,      2,      2,},
				{      3,      3,      3,      3,      3,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      6,      6,      6,      6,      6,},
				{      5,      5,      5,      6,      6,      6,      6,      6,      6,      6,      7,      7,      7,      7,      7,      7,      8,      8,      8,      8,      8,      8,      9,      9,      9,      9,      9,      9,      9,     10,     10,     10,},
				{      7,      7,      8,      8,      8,      8,      8,      9,      9,      9,      9,     10,     10,     10,     10,     10,     11,     11,     11,     11,     11,     12,     12,     12,     12,     13,     13,     13,     13,     13,     14,     14,},
				{      9,      9,     10,     10,     10,     11,     11,     11,     11,     12,     12,     12,     13,     13,     13,     13,     14,     14,     14,     14,     15,     15,     15,     16,     16,     16,     16,     17,     17,     17,     18,     18,},
				{     11,     12,     12,     12,     13,     13,     13,     14,     14,     14,     15,     15,     15,     16,     16,     16,     17,     17,     17,     18,     18,     18,     19,     19,     19,     20,     20,     20,     21,     21,     21,     22,},
				{     13,     14,     14,     14,     15,     15,     16,     16,     16,     17,     17,     18,     18,     18,     19,     19,     20,     20,     21,     21,     21,     22,     22,     23,     23,     23,     24,     24,     25,     25,     25,     26,},
				{     15,     16,     16,     17,     17,     18,     18,     19,     19,     19,     20,     20,     21,     21,     22,     22,     23,     23,     24,     24,     25,     25,     26,     26,     26,     27,     27,     28,     28,     29,     29,     30,},
				{     17,     18,     18,     19,     19,     20,     20,     21,     22,     22,     23,     23,     24,     24,     25,     25,     26,     26,     27,     27,     28,     28,     29,     29,     30,     31,     31,     32,     32,     33,     33,     34,},
				{     19,     20,     20,     21,     22,     22,     23,     23,     24,     25,     25,     26,     26,     27,     28,     28,     29,     29,     30,     31,     31,     32,     32,     33,     34,     34,     35,     35,     36,     37,     37,     38,},
				{     21,     22,     23,     23,     24,     25,     25,     26,     27,     27,     28,     29,     29,     30,     31,     31,     32,     32,     33,     34,     34,     35,     36,     36,     37,     38,     38,     39,     40,     40,     41,     42,},
				{     23,     24,     25,     26,     26,     27,     28,     28,     29,     30,     31,     31,     32,     33,     33,     34,     35,     36,     36,     37,     38,     38,     39,     40,     41,     41,     42,     43,     43,     44,     45,     46,},
				{     25,     26,     27,     28,     29,     29,     30,     31,     32,     32,     33,     34,     35,     36,     36,     37,     38,     39,     39,     40,     41,     42,     43,     43,     44,     45,     46,     46,     47,     48,     49,     50,},
				{     27,     28,     29,     30,     31,     32,     32,     33,     34,     35,     36,     37,     38,     38,     39,     40,     41,     42,     43,     43,     44,     45,     46,     47,     48,     49,     49,     50,     51,     52,     53,     54,},
				{     29,     30,     31,     32,     33,     34,     35,     36,     37,     38,     39,     39,     40,     41,     42,     43,     44,     45,     46,     47,     48,     48,     49,     50,     51,     52,     53,     54,     55,     56,     57,     58,},
				{     31,     32,     33,     34,     35,     36,     37,     38,     39,     40,     41,     42,     43,     44,     45,     46,     47,     48,     49,     50,     51,     52,     53,     54,     55,     56,     57,     58,     59,     60,     61,     62,},
				{     34,     35,     36,     37,     38,     39,     40,     41,     42,     43,     44,     45,     46,     47,     48,     49,     50,     51,     52,     53,     54,     55,     56,     57,     58,     59,     60,     61,     62,     63,     64,     65,},
				{     36,     37,     38,     39,     40,     41,     42,     43,     44,     45,     46,     48,     49,     50,     51,     52,     53,     54,     55,     56,     57,     59,     60,     61,     62,     63,     64,     65,     66,     67,     68,     69,},
				{     38,     39,     40,     41,     42,     43,     45,     46,     47,     48,     49,     50,     51,     53,     54,     55,     56,     57,     58,     60,     61,     62,     63,     64,     65,     66,     68,     69,     70,     71,     72,     73,},
				{     40,     41,     42,     43,     44,     46,     47,     48,     49,     51,     52,     53,     54,     55,     57,     58,     59,     60,     62,     63,     64,     65,     66,     68,     69,     70,     71,     73,     74,     75,     76,     77,},
				{     42,     43,     44,     45,     47,     48,     49,     51,     52,     53,     54,     56,     57,     58,     60,     61,     62,     63,     65,     66,     67,     69,     70,     71,     72,     74,     75,     76,     78,     79,     80,     81,},
				{     44,     45,     46,     48,     49,     50,     52,     53,     54,     56,     57,     58,     60,     61,     62,     64,     65,     67,     68,     69,     71,     72,     73,     75,     76,     77,     79,     80,     81,     83,     84,     85,},
				{     46,     47,     49,     50,     51,     53,     54,     56,     57,     58,     60,     61,     63,     64,     65,     67,     68,     70,     71,     72,     74,     75,     77,     78,     79,     81,     82,     84,     85,     86,     88,     89,},
				{     48,     49,     51,     52,     54,     55,     57,     58,     59,     61,     62,     64,     65,     67,     68,     70,     71,     73,     74,     76,     77,     79,     80,     82,     83,     84,     86,     87,     89,     90,     92,     93,},
				{     50,     51,     53,     54,     56,     57,     59,     60,     62,     64,     65,     67,     68,     70,     71,     73,     74,     76,     77,     79,     80,     82,     83,     85,     87,     88,     90,     91,     93,     94,     96,     97,},
				{     52,     53,     55,     57,     58,     60,     61,     63,     65,     66,     68,     69,     71,     73,     74,     76,     77,     79,     80,     82,     84,     85,     87,     88,     90,     92,     93,     95,     96,     98,    100,    101,},
				{     54,     55,     57,     59,     60,     62,     64,     65,     67,     69,     70,     72,     74,     75,     77,     79,     80,     82,     84,     85,     87,     89,     90,     92,     94,     95,     97,     99,    100,    102,    104,    105,},
				{     56,     58,     59,     61,     63,     64,     66,     68,     70,     71,     73,     75,     76,     78,     80,     82,     83,     85,     87,     89,     90,     92,     94,     95,     97,     99,    101,    102,    104,    106,    107,    109,},
				{     58,     60,     61,     63,     65,     67,     69,     70,     72,     74,     76,     77,     79,     81,     83,     85,     86,     88,     90,     92,     94,     95,     97,     99,    101,    102,    104,    106,    108,    110,    111,    113,},
				{     60,     62,     64,     65,     67,     69,     71,     73,     75,     77,     78,     80,     82,     84,     86,     88,     89,     91,     93,     95,     97,     99,    100,    102,    104,    106,    108,    110,    112,    113,    115,    117,},
				{     62,     64,     66,     68,     70,     71,     73,     75,     77,     79,     81,     83,     85,     87,     89,     91,     92,     94,     96,     98,    100,    102,    104,    106,    108,    110,    112,    113,    115,    117,    119,    121,},
				{     64,     66,     68,     70,     72,     74,     76,     78,     80,     82,     84,     86,     88,     90,     92,     94,     95,     97,     99,    101,    103,    105,    107,    109,    111,    113,    115,    117,    119,    121,    123,    125,},
				{     66,     68,     70,     72,     74,     76,     78,     80,     82,     84,     86,     88,     90,     92,     94,     96,     99,    101,    103,    105,    107,    109,    111,    113,    115,    117,    119,    121,    123,    125,    127,    129,},
				{     68,     70,     72,     74,     76,     79,     81,     83,     85,     87,     89,     91,     93,     95,     97,     99,    102,    104,    106,    108,    110,    112,    114,    116,    118,    120,    122,    125,    127,    129,    131,    133,},
				{     70,     72,     74,     77,     79,     81,     83,     85,     87,     89,     92,     94,     96,     98,    100,    102,    105,    107,    109,    111,    113,    115,    118,    120,    122,    124,    126,    128,    130,    133,    135,    137,},
				{     72,     74,     77,     79,     81,     83,     85,     88,     90,     92,     94,     97,     99,    101,    103,    105,    108,    110,    112,    114,    116,    119,    121,    123,    125,    128,    130,    132,    134,    136,    139,    141,},
				{     74,     76,     79,     81,     83,     86,     88,     90,     92,     95,     97,     99,    102,    104,    106,    108,    111,    113,    115,    117,    120,    122,    124,    127,    129,    131,    133,    136,    138,    140,    143,    145,},
				{     76,     79,     81,     83,     86,     88,     90,     93,     95,     97,    100,    102,    104,    107,    109,    111,    114,    116,    118,    121,    123,    125,    128,    130,    132,    135,    137,    139,    142,    144,    146,    149,},
				{     78,     81,     83,     85,     88,     90,     93,     95,     97,    100,    102,    105,    107,    109,    112,    114,    117,    119,    122,    124,    126,    129,    131,    134,    136,    138,    141,    143,    146,    148,    150,    153,},
				{     80,     83,     85,     88,     90,     93,     95,     98,    100,    102,    105,    107,    110,    112,    115,    117,    120,    122,    125,    127,    130,    132,    135,    137,    139,    142,    144,    147,    149,    152,    154,    157,},
				{     82,     85,     87,     90,     92,     95,     97,    100,    103,    105,    108,    110,    113,    115,    118,    120,    123,    125,    128,    130,    133,    135,    138,    140,    143,    146,    148,    151,    153,    156,    158,    161,},
				{     84,     87,     89,     92,     95,     97,    100,    102,    105,    108,    110,    113,    115,    118,    121,    123,    126,    128,    131,    134,    136,    139,    141,    144,    147,    149,    152,    154,    157,    160,    162,    165,},
				{     86,     89,     92,     94,     97,    100,    102,    105,    108,    110,    113,    116,    118,    121,    124,    126,    129,    131,    134,    137,    139,    142,    145,    147,    150,    153,    155,    158,    161,    163,    166,    169,},
				{     88,     91,     94,     97,     99,    102,    105,    107,    110,    113,    116,    118,    121,    124,    126,    129,    132,    135,    137,    140,    143,    145,    148,    151,    154,    156,    159,    162,    164,    167,    170,    173,},
				{     90,     93,     96,     99,    102,    104,    107,    110,    113,    115,    118,    121,    124,    127,    129,    132,    135,    138,    140,    143,    146,    149,    152,    154,    157,    160,    163,    165,    168,    171,    174,    177,},
				{     92,     95,     98,    101,    104,    107,    109,    112,    115,    118,    121,    124,    127,    129,    132,    135,    138,    141,    144,    146,    149,    152,    155,    158,    161,    164,    166,    169,    172,    175,    178,    181,},
				{     94,     97,    100,    103,    106,    109,    112,    115,    118,    121,    124,    126,    129,    132,    135,    138,    141,    144,    147,    150,    153,    155,    158,    161,    164,    167,    170,    173,    176,    179,    182,    185,},
				{     96,     99,    102,    105,    108,    111,    114,    117,    120,    123,    126,    129,    132,    135,    138,    141,    144,    147,    150,    153,    156,    159,    162,    165,    168,    171,    174,    177,    180,    183,    186,    189,},
				{     99,    102,    105,    108,    111,    114,    117,    120,    123,    126,    129,    132,    135,    138,    141,    144,    147,    150,    153,    156,    159,    162,    165,    168,    171,    174,    177,    180,    183,    186,    189,    192,},
				{    101,    104,    107,    110,    113,    116,    119,    122,    125,    128,    131,    135,    138,    141,    144,    147,    150,    153,    156,    159,    162,    166,    169,    172,    175,    178,    181,    184,    187,    190,    193,    196,},
				{    103,    106,    109,    112,    115,    118,    122,    125,    128,    131,    134,    137,    140,    144,    147,    150,    153,    156,    159,    163,    166,    169,    172,    175,    178,    181,    185,    188,    191,    194,    197,    200,},
				{    105,    108,    111,    114,    117,    121,    124,    127,    130,    134,    137,    140,    143,    146,    150,    153,    156,    159,    163,    166,    169,    172,    175,    179,    182,    185,    188,    192,    195,    198,    201,    204,},
				{    107,    110,    113,    116,    120,    123,    126,    130,    133,    136,    139,    143,    146,    149,    153,    156,    159,    162,    166,    169,    172,    176,    179,    182,    185,    189,    192,    195,    199,    202,    205,    208,},
				{    109,    112,    115,    119,    122,    125,    129,    132,    135,    139,    142,    145,    149,    152,    155,    159,    162,    166,    169,    172,    176,    179,    182,    186,    189,    192,    196,    199,    202,    206,    209,    212,},
				{    111,    114,    118,    121,    124,    128,    131,    135,    138,    141,    145,    148,    152,    155,    158,    162,    165,    169,    172,    175,    179,    182,    186,    189,    192,    196,    199,    203,    206,    209,    213,    216,},
				{    113,    116,    120,    123,    127,    130,    134,    137,    140,    144,    147,    151,    154,    158,    161,    165,    168,    172,    175,    179,    182,    186,    189,    193,    196,    199,    203,    206,    210,    213,    217,    220,},
				{    115,    118,    122,    125,    129,    132,    136,    139,    143,    147,    150,    154,    157,    161,    164,    168,    171,    175,    178,    182,    185,    189,    192,    196,    200,    203,    207,    210,    214,    217,    221,    224,},
				{    117,    120,    124,    128,    131,    135,    138,    142,    146,    149,    153,    156,    160,    164,    167,    171,    174,    178,    181,    185,    189,    192,    196,    199,    203,    207,    210,    214,    217,    221,    225,    228,},
				{    119,    122,    126,    130,    133,    137,    141,    144,    148,    152,    155,    159,    163,    166,    170,    174,    177,    181,    185,    188,    192,    196,    199,    203,    207,    210,    214,    218,    221,    225,    229,    232,},
				{    121,    125,    128,    132,    136,    139,    143,    147,    151,    154,    158,    162,    165,    169,    173,    177,    180,    184,    188,    192,    195,    199,    203,    206,    210,    214,    218,    221,    225,    229,    232,    236,},
				{    123,    127,    130,    134,    138,    142,    146,    149,    153,    157,    161,    164,    168,    172,    176,    180,    183,    187,    191,    195,    199,    202,    206,    210,    214,    217,    221,    225,    229,    233,    236,    240,},
				{    125,    129,    133,    136,    140,    144,    148,    152,    156,    160,    163,    167,    171,    175,    179,    183,    186,    190,    194,    198,    202,    206,    209,    213,    217,    221,    225,    229,    233,    236,    240,    244,},
				{    127,    131,    135,    139,    143,    146,    150,    154,    158,    162,    166,    170,    174,    178,    182,    186,    189,    193,    197,    201,    205,    209,    213,    217,    221,    225,    229,    232,    236,    240,    244,    248,},
				{    129,    133,    137,    141,    145,    149,    153,    157,    161,    165,    169,    173,    177,    181,    185,    189,    192,    196,    200,    204,    208,    212,    216,    220,    224,    228,    232,    236,    240,    244,    248,    252,},
				{    131,    135,    139,    143,    147,    151,    155,    159,    163,    167,    171,    175,    179,    183,    187,    191,    196,    200,    204,    208,    212,    216,    220,    224,    228,    232,    236,    240,    244,    248,    252,    256,},
				{    133,    137,    141,    145,    149,    154,    158,    162,    166,    170,    174,    178,    182,    186,    190,    194,    199,    203,    207,    211,    215,    219,    223,    227,    231,    235,    239,    244,    248,    252,    256,    260,},
				{    135,    139,    143,    148,    152,    156,    160,    164,    168,    172,    177,    181,    185,    189,    193,    197,    202,    206,    210,    214,    218,    222,    227,    231,    235,    239,    243,    247,    251,    256,    260,    264,},
				{    137,    141,    146,    150,    154,    158,    162,    167,    171,    175,    179,    184,    188,    192,    196,    200,    205,    209,    213,    217,    221,    226,    230,    234,    238,    243,    247,    251,    255,    259,    264,    268,},
				{    139,    143,    148,    152,    156,    161,    165,    169,    173,    178,    182,    186,    191,    195,    199,    203,    208,    212,    216,    220,    225,    229,    233,    238,    242,    246,    250,    255,    259,    263,    268,    272,},
				{    141,    146,    150,    154,    159,    163,    167,    172,    176,    180,    185,    189,    193,    198,    202,    206,    211,    215,    219,    224,    228,    232,    237,    241,    245,    250,    254,    258,    263,    267,    271,    276,},
				{    143,    148,    152,    156,    161,    165,    170,    174,    178,    183,    187,    192,    196,    200,    205,    209,    214,    218,    223,    227,    231,    236,    240,    245,    249,    253,    258,    262,    267,    271,    275,    280,},
				{    145,    150,    154,    159,    163,    168,    172,    177,    181,    185,    190,    194,    199,    203,    208,    212,    217,    221,    226,    230,    235,    239,    244,    248,    252,    257,    261,    266,    270,    275,    279,    284,},
				{    147,    152,    156,    161,    165,    170,    174,    179,    184,    188,    193,    197,    202,    206,    211,    215,    220,    224,    229,    233,    238,    242,    247,    251,    256,    261,    265,    270,    274,    279,    283,    288,},
				{    149,    154,    158,    163,    168,    172,    177,    181,    186,    191,    195,    200,    204,    209,    214,    218,    223,    227,    232,    237,    241,    246,    250,    255,    260,    264,    269,    273,    278,    283,    287,    292,},
				{    151,    156,    161,    165,    170,    175,    179,    184,    189,    193,    198,    203,    207,    212,    217,    221,    226,    230,    235,    240,    244,    249,    254,    258,    263,    268,    272,    277,    282,    286,    291,    296,},
				{    153,    158,    163,    168,    172,    177,    182,    186,    191,    196,    201,    205,    210,    215,    219,    224,    229,    234,    238,    243,    248,    252,    257,    262,    267,    271,    276,    281,    285,    290,    295,    300,},
				{    155,    160,    165,    170,    175,    179,    184,    189,    194,    198,    203,    208,    213,    218,    222,    227,    232,    237,    241,    246,    251,    256,    261,    265,    270,    275,    280,    284,    289,    294,    299,    304,},
				{    157,    162,    167,    172,    177,    182,    186,    191,    196,    201,    206,    211,    216,    220,    225,    230,    235,    240,    245,    249,    254,    259,    264,    269,    274,    279,    283,    288,    293,    298,    303,    308,},
				{    159,    164,    169,    174,    179,    184,    189,    194,    199,    204,    209,    213,    218,    223,    228,    233,    238,    243,    248,    253,    258,    262,    267,    272,    277,    282,    287,    292,    297,    302,    307,    312,},
				{    161,    166,    171,    176,    181,    186,    191,    196,    201,    206,    211,    216,    221,    226,    231,    236,    241,    246,    251,    256,    261,    266,    271,    276,    281,    286,    291,    296,    301,    306,    311,    316,},
				{    164,    169,    174,    179,    184,    189,    194,    199,    204,    209,    214,    219,    224,    229,    234,    239,    244,    249,    254,    259,    264,    269,    274,    279,    284,    289,    294,    299,    304,    309,    314,    319,},
				{    166,    171,    176,    181,    186,    191,    196,    201,    206,    211,    216,    222,    227,    232,    237,    242,    247,    252,    257,    262,    267,    273,    278,    283,    288,    293,    298,    303,    308,    313,    318,    323,},
				{    168,    173,    178,    183,    188,    193,    199,    204,    209,    214,    219,    224,    229,    235,    240,    245,    250,    255,    260,    266,    271,    276,    281,    286,    291,    296,    302,    307,    312,    317,    322,    327,},
				{    170,    175,    180,    185,    190,    196,    201,    206,    211,    217,    222,    227,    232,    237,    243,    248,    253,    258,    264,    269,    274,    279,    284,    290,    295,    300,    305,    311,    316,    321,    326,    331,},
				{    172,    177,    182,    187,    193,    198,    203,    209,    214,    219,    224,    230,    235,    240,    246,    251,    256,    261,    267,    272,    277,    283,    288,    293,    298,    304,    309,    314,    320,    325,    330,    335,},
				{    174,    179,    184,    190,    195,    200,    206,    211,    216,    222,    227,    232,    238,    243,    248,    254,    259,    265,    270,    275,    281,    286,    291,    297,    302,    307,    313,    318,    323,    329,    334,    339,},
				{    176,    181,    187,    192,    197,    203,    208,    214,    219,    224,    230,    235,    241,    246,    251,    257,    262,    268,    273,    278,    284,    289,    295,    300,    305,    311,    316,    322,    327,    332,    338,    343,},
				{    178,    183,    189,    194,    200,    205,    211,    216,    221,    227,    232,    238,    243,    249,    254,    260,    265,    271,    276,    282,    287,    293,    298,    304,    309,    314,    320,    325,    331,    336,    342,    347,},
				{    180,    185,    191,    196,    202,    207,    213,    218,    224,    230,    235,    241,    246,    252,    257,    263,    268,    274,    279,    285,    290,    296,    301,    307,    313,    318,    324,    329,    335,    340,    346,    351,},
				{    182,    187,    193,    199,    204,    210,    215,    221,    227,    232,    238,    243,    249,    255,    260,    266,    271,    277,    282,    288,    294,    299,    305,    310,    316,    322,    327,    333,    338,    344,    350,    355,},
				{    184,    189,    195,    201,    206,    212,    218,    223,    229,    235,    240,    246,    252,    257,    263,    269,    274,    280,    286,    291,    297,    303,    308,    314,    320,    325,    331,    337,    342,    348,    354,    359,},
				{    186,    192,    197,    203,    209,    214,    220,    226,    232,    237,    243,    249,    254,    260,    266,    272,    277,    283,    289,    295,    300,    306,    312,    317,    323,    329,    335,    340,    346,    352,    357,    363,},
				{    188,    194,    199,    205,    211,    217,    223,    228,    234,    240,    246,    251,    257,    263,    269,    275,    280,    286,    292,    298,    304,    309,    315,    321,    327,    332,    338,    344,    350,    356,    361,    367,},
				{    190,    196,    202,    207,    213,    219,    225,    231,    237,    243,    248,    254,    260,    266,    272,    278,    283,    289,    295,    301,    307,    313,    318,    324,    330,    336,    342,    348,    354,    359,    365,    371,},
				{    192,    198,    204,    210,    216,    221,    227,    233,    239,    245,    251,    257,    263,    269,    275,    281,    286,    292,    298,    304,    310,    316,    322,    328,    334,    340,    346,    351,    357,    363,    369,    375,},
				{    194,    200,    206,    212,    218,    224,    230,    236,    242,    248,    254,    260,    266,    272,    278,    284,    289,    295,    301,    307,    313,    319,    325,    331,    337,    343,    349,    355,    361,    367,    373,    379,},
				{    196,    202,    208,    214,    220,    226,    232,    238,    244,    250,    256,    262,    268,    274,    280,    286,    293,    299,    305,    311,    317,    323,    329,    335,    341,    347,    353,    359,    365,    371,    377,    383,},
				{    198,    204,    210,    216,    222,    229,    235,    241,    247,    253,    259,    265,    271,    277,    283,    289,    296,    302,    308,    314,    320,    326,    332,    338,    344,    350,    356,    363,    369,    375,    381,    387,},
				{    200,    206,    212,    219,    225,    231,    237,    243,    249,    255,    262,    268,    274,    280,    286,    292,    299,    305,    311,    317,    323,    329,    336,    342,    348,    354,    360,    366,    372,    379,    385,    391,},
				{    202,    208,    215,    221,    227,    233,    239,    246,    252,    258,    264,    271,    277,    283,    289,    295,    302,    308,    314,    320,    326,    333,    339,    345,    351,    358,    364,    370,    376,    382,    389,    395,},
				{    204,    210,    217,    223,    229,    236,    242,    248,    254,    261,    267,    273,    280,    286,    292,    298,    305,    311,    317,    323,    330,    336,    342,    349,    355,    361,    367,    374,    380,    386,    393,    399,},
				{    206,    213,    219,    225,    232,    238,    244,    251,    257,    263,    270,    276,    282,    289,    295,    301,    308,    314,    320,    327,    333,    339,    346,    352,    358,    365,    371,    377,    384,    390,    396,    403,},
				{    208,    215,    221,    227,    234,    240,    247,    253,    259,    266,    272,    279,    285,    291,    298,    304,    311,    317,    324,    330,    336,    343,    349,    356,    362,    368,    375,    381,    388,    394,    400,    407,},
				{    210,    217,    223,    230,    236,    243,    249,    256,    262,    268,    275,    281,    288,    294,    301,    307,    314,    320,    327,    333,    340,    346,    353,    359,    365,    372,    378,    385,    391,    398,    404,    411,},
				{    212,    219,    225,    232,    238,    245,    251,    258,    265,    271,    278,    284,    291,    297,    304,    310,    317,    323,    330,    336,    343,    349,    356,    362,    369,    376,    382,    389,    395,    402,    408,    415,},
				{    214,    221,    227,    234,    241,    247,    254,    260,    267,    274,    280,    287,    293,    300,    307,    313,    320,    326,    333,    340,    346,    353,    359,    366,    373,    379,    386,    392,    399,    406,    412,    419,},
				{    216,    223,    230,    236,    243,    250,    256,    263,    270,    276,    283,    290,    296,    303,    310,    316,    323,    329,    336,    343,    349,    356,    363,    369,    376,    383,    389,    396,    403,    409,    416,    423,},
				{    218,    225,    232,    239,    245,    252,    259,    265,    272,    279,    286,    292,    299,    306,    312,    319,    326,    333,    339,    346,    353,    359,    366,    373,    380,    386,    393,    400,    406,    413,    420,    427,},
				{    220,    227,    234,    241,    248,    254,    261,    268,    275,    281,    288,    295,    302,    309,    315,    322,    329,    336,    342,    349,    356,    363,    370,    376,    383,    390,    397,    403,    410,    417,    424,    431,},
				{    222,    229,    236,    243,    250,    257,    263,    270,    277,    284,    291,    298,    305,    311,    318,    325,    332,    339,    346,    352,    359,    366,    373,    380,    387,    394,    400,    407,    414,    421,    428,    435,},
				{    224,    231,    238,    245,    252,    259,    266,    273,    280,    287,    294,    300,    307,    314,    321,    328,    335,    342,    349,    356,    363,    369,    376,    383,    390,    397,    404,    411,    418,    425,    432,    439,},
				{    226,    233,    240,    247,    254,    261,    268,    275,    282,    289,    296,    303,    310,    317,    324,    331,    338,    345,    352,    359,    366,    373,    380,    387,    394,    401,    408,    415,    422,    429,    436,    443,},
				{    229,    236,    243,    250,    257,    264,    271,    278,    285,    292,    299,    306,    313,    320,    327,    334,    341,    348,    355,    362,    369,    376,    383,    390,    397,    404,    411,    418,    425,    432,    439,    446,},
				{    231,    238,    245,    252,    259,    266,    273,    280,    287,    294,    301,    309,    316,    323,    330,    337,    344,    351,    358,    365,    372,    380,    387,    394,    401,    408,    415,    422,    429,    436,    443,    450,},
				{    233,    240,    247,    254,    261,    268,    276,    283,    290,    297,    304,    311,    318,    326,    333,    340,    347,    354,    361,    369,    376,    383,    390,    397,    404,    411,    419,    426,    433,    440,    447,    454,},
				{    235,    242,    249,    256,    263,    271,    278,    285,    292,    300,    307,    314,    321,    328,    336,    343,    350,    357,    365,    372,    379,    386,    393,    401,    408,    415,    422,    430,    437,    444,    451,    458,},
				{    237,    244,    251,    258,    266,    273,    280,    288,    295,    302,    309,    317,    324,    331,    339,    346,    353,    360,    368,    375,    382,    390,    397,    404,    411,    419,    426,    433,    441,    448,    455,    462,},
				{    239,    246,    253,    261,    268,    275,    283,    290,    297,    305,    312,    319,    327,    334,    341,    349,    356,    364,    371,    378,    386,    393,    400,    408,    415,    422,    430,    437,    444,    452,    459,    466,},
				{    241,    248,    256,    263,    270,    278,    285,    293,    300,    307,    315,    322,    330,    337,    344,    352,    359,    367,    374,    381,    389,    396,    404,    411,    418,    426,    433,    441,    448,    455,    463,    470,},
				{    243,    250,    258,    265,    273,    280,    288,    295,    302,    310,    317,    325,    332,    340,    347,    355,    362,    370,    377,    385,    392,    400,    407,    415,    422,    429,    437,    444,    452,    459,    467,    474,},
				{    245,    252,    260,    267,    275,    282,    290,    297,    305,    313,    320,    328,    335,    343,    350,    358,    365,    373,    380,    388,    395,    403,    410,    418,    426,    433,    441,    448,    456,    463,    471,    478,},
				{    247,    254,    262,    270,    277,    285,    292,    300,    308,    315,    323,    330,    338,    346,    353,    361,    368,    376,    383,    391,    399,    406,    414,    421,    429,    437,    444,    452,    459,    467,    475,    482,},
				{    249,    256,    264,    272,    279,    287,    295,    302,    310,    318,    325,    333,    341,    348,    356,    364,    371,    379,    387,    394,    402,    410,    417,    425,    433,    440,    448,    456,    463,    471,    479,    486,},
				{    251,    259,    266,    274,    282,    289,    297,    305,    313,    320,    328,    336,    343,    351,    359,    367,    374,    382,    390,    398,    405,    413,    421,    428,    436,    444,    452,    459,    467,    475,    482,    490,},
				{    253,    261,    268,    276,    284,    292,    300,    307,    315,    323,    331,    338,    346,    354,    362,    370,    377,    385,    393,    401,    409,    416,    424,    432,    440,    447,    455,    463,    471,    479,    486,    494,},
				{    255,    263,    271,    278,    286,    294,    302,    310,    318,    326,    333,    341,    349,    357,    365,    373,    380,    388,    396,    404,    412,    420,    427,    435,    443,    451,    459,    467,    475,    482,    490,    498,},
				{    257,    265,    273,    281,    289,    296,    304,    312,    320,    328,    336,    344,    352,    360,    368,    376,    383,    391,    399,    407,    415,    423,    431,    439,    447,    455,    463,    470,    478,    486,    494,    502,},
				{    259,    267,    275,    283,    291,    299,    307,    315,    323,    331,    339,    347,    355,    363,    371,    379,    386,    394,    402,    410,    418,    426,    434,    442,    450,    458,    466,    474,    482,    490,    498,    506,},
			};
#else
	const UChar TComCABACTables::sm_aucLPSTable[64][4] =
	{
	  { 128, 176, 208, 240},
	  { 128, 167, 197, 227},
	  { 128, 158, 187, 216},
	  { 123, 150, 178, 205},
	  { 116, 142, 169, 195},
	  { 111, 135, 160, 185},
	  { 105, 128, 152, 175},
	  { 100, 122, 144, 166},
	  {  95, 116, 137, 158},
	  {  90, 110, 130, 150},
	  {  85, 104, 123, 142},
	  {  81,  99, 117, 135},
	  {  77,  94, 111, 128},
	  {  73,  89, 105, 122},
	  {  69,  85, 100, 116},
	  {  66,  80,  95, 110},
	  {  62,  76,  90, 104},
	  {  59,  72,  86,  99},
	  {  56,  69,  81,  94},
	  {  53,  65,  77,  89},
	  {  51,  62,  73,  85},
	  {  48,  59,  69,  80},
	  {  46,  56,  66,  76},
	  {  43,  53,  63,  72},
	  {  41,  50,  59,  69},
	  {  39,  48,  56,  65},
	  {  37,  45,  54,  62},
	  {  35,  43,  51,  59},
	  {  33,  41,  48,  56},
	  {  32,  39,  46,  53},
	  {  30,  37,  43,  50},
	  {  29,  35,  41,  48},
	  {  27,  33,  39,  45},
	  {  26,  31,  37,  43},
	  {  24,  30,  35,  41},
	  {  23,  28,  33,  39},
	  {  22,  27,  32,  37},
	  {  21,  26,  30,  35},
	  {  20,  24,  29,  33},
	  {  19,  23,  27,  31},
	  {  18,  22,  26,  30},
	  {  17,  21,  25,  28},
	  {  16,  20,  23,  27},
	  {  15,  19,  22,  25},
	  {  14,  18,  21,  24},
	  {  14,  17,  20,  23},
	  {  13,  16,  19,  22},
	  {  12,  15,  18,  21},
	  {  12,  14,  17,  20},
	  {  11,  14,  16,  19},
	  {  11,  13,  15,  18},
	  {  10,  12,  15,  17},
	  {  10,  12,  14,  16},
	  {   9,  11,  13,  15},
	  {   9,  11,  12,  14},
	  {   8,  10,  12,  14},
	  {   8,   9,  11,  13},
	  {   7,   9,  11,  12},
	  {   7,   9,  10,  12},
	  {   7,   8,  10,  11},
	  {   6,   8,   9,  11},
	  {   6,   7,   9,  10},
	  {   6,   7,   8,   9},
	  {   2,   2,   2,   2}
	};
#endif
#endif




